package zero1hd.rhythmbullet.audio.visualizer;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;

public class MirrorVisualizer {
	private int xPos, yPos;
	private float rotation;
	private Sprite[] bars;
	private boolean flip;
	
	private Vector2 rectCoordRot;
	public MirrorVisualizer() {
		rectCoordRot = new Vector2();
	}
	
	protected void setup(Sprite[] bars, float xPos, float yPos, float rotation) {
		this.bars = new Sprite[bars.length];
		this.xPos = (int) xPos;
		this.yPos = (int) yPos;
		this.rotation = rotation;
		rectCoordRot.set(MathUtils.cosDeg(rotation), MathUtils.sinDeg(rotation));

		for (int i = 0; i < bars.length; i++) {
			this.bars[i] = new Sprite(bars[i]);
		}
	}
	
	public void render(Batch batch, float parentAlpha, Sprite[] bars) {
		for (int i = 0; i < this.bars.length; i++) {
			this.bars[i].setSize(bars[i].getWidth(), bars[i].getHeight());
			this.bars[i].draw(batch);
		}
	}
	
	public void position(int barWidth, int spaceBetweenBars) {
		int barSpaceMultiplier = barWidth + spaceBetweenBars;
		
		for (int i = 0; i < bars.length; i ++) {
			if (flip) {
				bars[i].setRotation(rotation+180);
			} else {
				bars[i].setRotation(rotation);
			}
			
			bars[i].setPosition(xPos + i*barSpaceMultiplier*rectCoordRot.x, yPos + i*barSpaceMultiplier*rectCoordRot.y);
		}
	}
	
	public float getRotation() {
		return rotation;
	}
	
	public void setRotation(float rotation) {
		this.rotation = rotation;
	}
	
	public void setyPos(int yPos) {
		this.yPos = yPos;
	}
	
	public void setxPos(int xPos) {
		this.xPos = xPos;
	}

}
