package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.utils.Disposable;

import zero1hd.rhythmbullet.audio.visualizer.MirrorVisualizer;
import zero1hd.rhythmbullet.graphics.meshes.TitleBarMesh;

public class TitleBarVisualizer extends Group implements Disposable {
	private Visualizer visual;
	private MirrorVisualizer visual2;
	private TitleBarMesh background;
	
	public TitleBarVisualizer(AssetManager assets, OrthographicCamera camera) {
		if (assets == null) throw new  NullPointerException("TitleBarVisualizer requires assets manager... ITS NULL YOU FOOL");
		visual = new Visualizer();
		visual.getVis().setSpaceBetweenBars(visual.getVis().getBarWidth()-3);
		addActor(visual);
		background = new TitleBarMesh();
		background.setHeight(MathUtils.round(Gdx.graphics.getHeight()*0.3f));
		
		setRotation((float) (MathUtils.radiansToDegrees*Math.atan2(Gdx.graphics.getHeight()-background.getHeight(), Gdx.graphics.getWidth())));
		setSize((float) Math.sqrt(Gdx.graphics.getWidth()*Gdx.graphics.getWidth() + Gdx.graphics.getHeight()*Gdx.graphics.getHeight()), ((float) background.getHeight())*MathUtils.sinDeg(90f-getRotation()));

		background.setCam(camera);
		
		visual.setWidth(getWidth());
		visual.setHeight(background.getHeight());
		visual.getVis().flip();
		visual.getVis().reverse();
		visual2 = new MirrorVisualizer();
		visual.getVis().addMirrorVisualizer(visual2);
		visual2.setRotation(visual.getRotation());
		visual2.setyPos(MathUtils.round(getHeight()));
	}
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		batch.end();
		background.draw();
		batch.begin();
		super.draw(batch, parentAlpha);
	}
	
	public Visualizer getHvisual() {
		return visual;
	}

	@Override
	public void dispose() {
		background.dispose();
	}
	
	@Override
	public void setColor(Color color) {
		super.setColor(color);
	}
	
	@Override
	public void setColor(float r, float g, float b, float a) {
		super.setColor(r, g, b, a);
	}
}
