package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.ui.Widget;

import zero1hd.rhythmbullet.audio.MusicManager;
import zero1hd.rhythmbullet.audio.visualizer.BasicVisualizer;

public class Visualizer extends Widget {
	private BasicVisualizer vis;
	private boolean updatePositioning = true;
	public Visualizer() {
		vis = new BasicVisualizer();
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		vis.render(batch, parentAlpha);
		super.draw(batch, parentAlpha);
	}
	
	@Override
	public void act(float delta) {
		vis.setHeight(getHeight());
		vis.setWidth(getWidth());
		vis.setxPos(getX());
		vis.setyPos(getY());
		vis.setRotation(getRotation());
		if (updatePositioning) {
			vis.updatePositionInfo();
		}
		vis.calculate();
		super.act(delta);
	}
	
	
	public void setMDP(MusicManager mdp) {
		vis.setMM(mdp);
	}
	
	@Override
	public void setColor(Color color) {
		vis.setColor(color);
		super.setColor(color);
	}
	
	@Override
	public void setColor(float r, float g, float b, float a) {
		vis.setColor(r, g, b, a);
		super.setColor(r, g, b, a);
	}
	
	public void setUpdatePositioning(boolean updatePositioning) {
		this.updatePositioning = updatePositioning;
	}
	
	public boolean isUpdatePositioning() {
		return updatePositioning;
	}
	
	public BasicVisualizer getVis() {
		return vis;
	}
}
