package zero1hd.rhythmbullet.graphics.ui.pages;

import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.math.Vector3;
import com.badlogic.gdx.scenes.scene2d.ui.Label;

import zero1hd.rhythmbullet.RhythmBullet;
import zero1hd.rhythmbullet.audio.MusicManager;
import zero1hd.rhythmbullet.audio.SongListController;
import zero1hd.rhythmbullet.events.OnDifferentSongListener;
import zero1hd.rhythmbullet.graphics.ui.components.TitleBarVisualizer;

public class MainPage extends Page implements OnDifferentSongListener {
	private Label versionLabel;
	
	private SongListController sc;
	private TitleBarVisualizer titleBar;
	public MainPage(RhythmBullet core, Vector3 targetPosition, SongListController sc, OrthographicCamera camera) {
		this.sc = sc;
		
		titleBar = new TitleBarVisualizer(core.getAssetManager(), camera);
		addActor(titleBar);
		
		titleBar.getHvisual().setMDP(sc.getCurrentSong());
		
		sc.addOnDifferentSongListener(this);
		
		versionLabel = new Label("Version: " + RhythmBullet.VERSION, core.getDefaultSkin(), "sub-font",
				core.getDefaultSkin().getColor("default"));
		versionLabel.setPosition(3, 3);
		addActor(versionLabel);
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		super.draw(batch, parentAlpha);
	}

	@Override
	public void onDifferentSong(MusicManager mdp) {
		titleBar.getHvisual().setMDP(mdp);
	}
	
	@Override
	public void dispose() {
		super.dispose();
	}
}
